//this programm will put out a PPM signal

//////////////////////CONFIGURATION///////////////////////////////
#define chanel_number 8  //set the number of chanels
#define default_servo_value 1000  //set the default servo value
#define PPM_FrLen 22500  //set the PPM frame length in microseconds (1ms = 1000µs)
#define PPM_PulseLen 300  //set the pulse length
#define onState 1  //set polarity of the pulses: 1 is positive, 0 is negative
#define sigPin 9  //set PPM signal output pin on the arduino
#define atc_pin 2  // activation button
#define arm_pin 3  // armed switch
#define arm_led 4  // led armed
#define act_led 5  // led activated
#define sev_par 1  // parachute servo channel (1=channel 2)
#define sev_mot 0  // power-off motor servo channel (0=channel 1)
#define para_delay 500  // delay from starting parachute before power-off (ms)
//////////////////////////////////////////////////////////////////


/*this array holds the servo values for the ppm signal
 change theese values in your code (usually servo values move between 1000 and 2000)*/
int ppm[chanel_number];
int activate =0;
int armed =0;
boolean locked = false;
int rssi =0;
unsigned long currentMillis = 0;
boolean actived = false;

void setup(){ 
    //initiallize default ppm values
  for(int i=0; i<chanel_number; i++){
    ppm[i]= default_servo_value;
  }

  pinMode(atc_pin, INPUT); // BUTTON ACTIVATE
  pinMode(arm_pin, INPUT); // ARM SWITCH
  pinMode(arm_led, OUTPUT); // LED ARMED
  pinMode(act_led, OUTPUT); // LED ACTIVATED
  pinMode(sigPin, OUTPUT); // PIN OUT PPM
  digitalWrite(sigPin, !onState);  //set the PPM signal pin to the default state (off)
  //prevent autoactivate
  activate = digitalRead(atc_pin);
  armed = digitalRead(arm_pin);
  if (activate == HIGH || armed == HIGH) {
    locked = true;
    }
    
  cli();
  TCCR1A = 0; // set entire TCCR1 register to 0
  TCCR1B = 0;
  
  OCR1A = 100;  // compare match register, change this
  TCCR1B |= (1 << WGM12);  // turn on CTC mode
  TCCR1B |= (1 << CS11);  // 8 prescaler: 0,5 microseconds at 16mhz
  TIMSK1 |= (1 << OCIE1A); // enable timer compare interrupt
  sei();
}

void loop(){
  //read input
  activate = digitalRead(atc_pin);
  armed = digitalRead(arm_pin);
  
  if (activate == HIGH && armed == LOW) {
    locked = true;
    }
  
  if ((armed == HIGH && activate == HIGH && locked == false) or actived == true) {
       //first.. need 250ms button press
    if(millis() - currentMillis > 250) {
      actived = true;
      digitalWrite(act_led, HIGH);
      } else {
      goto cont;
    }
    
    //second.. open parachute
    if (ppm[sev_par] < 1930){
      currentMillis = millis();
      ppm[sev_par] = 1930;
    }
      
  if(millis() - currentMillis > para_delay) {
    //third.. CUT-OFF (bye..bye)
    ppm[sev_mot] = 1930;
  }
    
    } else {
      currentMillis = millis();
    }
    
cont:
    if (armed == HIGH && locked == false){
    digitalWrite(arm_led, HIGH);
    } else {
    digitalWrite(arm_led, LOW);
    }
    
    //unlock
    if (activate == LOW && armed == LOW && locked == true){
    locked = false;
    }
  
   delay(10);
}

ISR(TIMER1_COMPA_vect){  //leave this alone
  static boolean state = true;
  
  TCNT1 = 0;
  
  if(state) {  //start pulse
    digitalWrite(sigPin, onState);
    OCR1A = PPM_PulseLen * 2;
    state = false;
  }
  else{  //end pulse and calculate when to start the next pulse
    static byte cur_chan_numb;
    static unsigned int calc_rest;
  
    digitalWrite(sigPin, !onState);
    state = true;

    if(cur_chan_numb >= chanel_number){
      cur_chan_numb = 0;
      calc_rest = calc_rest + PPM_PulseLen;// 
      OCR1A = (PPM_FrLen - calc_rest) * 2;
      calc_rest = 0;
    }
    else{
      OCR1A = (ppm[cur_chan_numb] - PPM_PulseLen) * 2;
      calc_rest = calc_rest + ppm[cur_chan_numb];
      cur_chan_numb++;
    }     
  }
}
